*!*	---------------------------------------- /*
*!*	CheckAccount
*!*	---------------------------------------- /*
*!*	  20-   
*!*	    20-  
*!*	(, ,   ..)
*!*	---------------------------------------- /*
*!*	
*!*	1. tcAccount - 20-    ( )
*!*	2. tcBIK - 9-  .    ,    
*!*	3. tlIsCorAccount-       
*!*		.T. - ,  .
*!*		.F. -  (-),   .
*!*	!!!  !!!
*!*	       , 
*!*	      
*!*	---------------------------------------- /*
*!*	 
*!*	-  -   ,      9
*!*	       .
*!*	-    20 
*!*	-     ,   6      
*!*	  -       ( )
*!*	-        
*!*	-      9  
*!*	-      
*!*	---------------------------------------- /*
*!*	 .T. -      .F. -  
*!*	---------------------------------------- /*
*!*	
*!*	       (Jimmy),    
*!*	      .        
*!*	          
*!*	---------------------------------------- /*


PARAMETERS tcAccount,tcBIK,tlIsCorAccount

LOCAL llIsCorrect
llIsCorrect = .T.
*       
*         
IF TYPE("tlIsCorAccount")<>"L"
	tlIsCorAccount=.F.
ENDIF

DO CASE
CASE TYPE("tcBIK")="C"
	tcBIK=AllTrim(m.tcBIK)
CASE TYPE("tcBIK")="N"
	tcBIK=LTRIM(STR(m.tcBIK,20))
OTHERWISE
	llIsCorrect = .F.
ENDCASE

IF LEN(m.tcBIK)>9
	llIsCorrect = .F.
ELSE
	tcBIK=PADL(m.tcBIK,9,"0")
ENDIF

IF TYPE("tcAccount")="C"
	tcAccount = UPPER(AllTrim(m.tcAccount))
	IF LEN(m.tcAccount)<>20
		llIsCorrect = .F.
	ENDIF
ELSE
	llIsCorrect = .F.
ENDIF

LOCAL lnI
*   
IF m.llIsCorrect = .T.
	FOR lnI=1 TO LEN(m.tcBIK)
		IF IsDigit(SubStr(m.tcBIK,m.lnI,1))=.F.
			llIsCorrect = .F.
		ENDIF
	ENDFOR
ENDIF

* ,   6  ,       
*  ,      (Lat+)       
LOCAL lcPossibleCharacters, lcChangingDigits
lcPossibleCharacters = 'ABCEHKMPTX'
lcChangingDigits = '01234567890123456789'

*   
IF llIsCorrect = .T.
	FOR lnI=1 TO LEN(m.tcAccount)
		IF IsDigit(SubStr(m.tcAccount,m.lnI,1))=.F.
			IF m.lnI=6 AND SubStr(m.tcAccount,m.lnI,1) $ m.lcPossibleCharacters
				*   6      , 
				*      
				tcAccount = LEFT(m.tcAccount,5)+;
							SubStr(m.lcChangingDigits,AT(SubStr(m.tcAccount,m.lnI,1),m.lcPossibleCharacters),1)+;
							RIGHT(m.tcAccount,14)
			ELSE
				llIsCorrect = .F.
			ENDIF
		ENDIF
	ENDFOR
ENDIF

*        
LOCAL laVes(20)
laVes(1)=7
laVes(2)=1
laVes(3)=3
laVes(4)=7
laVes(5)=1
laVes(6)=3
laVes(7)=7
laVes(8)=1
laVes(9)=3
laVes(10)=7
laVes(11)=1
laVes(12)=3
laVes(13)=7
laVes(14)=1
laVes(15)=3
laVes(16)=7
laVes(17)=1
laVes(18)=3
laVes(19)=7
laVes(20)=1

*   
IF m.llIsCorrect = .T.

	*        
	*       
	*     
	LOCAL lcCheckStringBIK
	IF VAL(SUBSTR(m.tcBIK,7,3)) < 10 OR m.tlIsCorAccount=.T.
		lcCheckStringBIK = '0'+SUBSTR(m.tcBIK,5,2)	&&   
	ELSE
		lcCheckStringBIK = SUBSTR(m.tcBIK,7,3)		&&    
	ENDIF

	*  2    
	LOCAL lnCheckSum9, lnCheckSumAccount
	STORE 0 TO m.lnCheckSum9, m.lnCheckSumAccount
	FOR lnI=1 TO 3
		lnCheckSum9 = m.lnCheckSum9 + VAL(SubStr(m.lcCheckStringBIK,m.lnI,1))*laVes(m.lnI)
		lnCheckSumAccount = m.lnCheckSumAccount + VAL(SubStr(m.lcCheckStringBIK,m.lnI,1))*laVes(m.lnI)
	ENDFOR
	FOR lnI=1 TO 20
		IF m.lnI<>9
			lnCheckSum9 = m.lnCheckSum9 + VAL(SubStr(m.tcAccount,m.lnI,1))*laVes(m.lnI)
		ENDIF
		lnCheckSumAccount = m.lnCheckSumAccount + VAL(SubStr(m.tcAccount,m.lnI,1))*laVes(m.lnI)
	ENDFOR
	
	lnCheckSum9 = MOD(MOD(m.lnCheckSum9,10)*laVes(9),10)
	lnCheckSumAccount = MOD(m.lnCheckSumAccount,10)
	
	*      
	IF VAL(SubStr(m.tcAccount,9,1))<>m.lnCheckSum9 OR m.lnCheckSumAccount<>0
		llIsCorrect=.F.
	ENDIF
ENDIF

RETURN (m.llIsCorrect)