*!*	---------------------------------------- /*
*!*	CheckINN
*!*	---------------------------------------- /*
*!*	  
*!*	---------------------------------------- /*
*!*	
*!*	1. tcINN -  ,   
*!*				   ,    
*!*	!!!  !!!
*!*	       , 
*!*	      
*!*	---------------------------------------- /*
*!*	 .T. -      .F. -  
*!*	---------------------------------------- /*
*!*	
*!*	         
*!*	http://myriadsoftware.al.ru/rus/documents/article03.html
*!*	---------------------------------------- /*
*!*	 :     
*!*	10-   - NNNNXXXXXC
*!*	11-   - FNNNNXXXXXC
*!*	12-   - NNNNXXXXXXCC
*!*	: NNNN -   
*!*	XXXXX, XXXXXX -   
*!*	(   )
*!*	C -    10-  
*!*	CC -    12-  
*!*	(,     )
*!*	F -   () "F",       
*!*	  11-     10-  

PARAMETERS tcINN

LOCAL llIsCorrect
llIsCorrect = .T.
*      
*      
DO CASE
CASE TYPE("tcINN")="N"
	tcINN=LTRIM(STR(m.tcINN,20))
CASE TYPE("tcINN")="C"
	tcINN=ALLTRIM(m.tcINN)
OTHERWISE
	llIsCorrect = .F.
ENDCASE

*     ( )
IF m.llIsCorrect = .T. 
	DO CASE
	CASE LEN(m.tcINN)<=10
		tcINN=PADL(m.tcINN,10,"0")
	CASE LEN(m.tcINN)=11
		IF LEFT(m.tcINN,1)="F"
			tcINN = SubStr(m.tcINN,2,10)
		ELSE
			llIsCorrect = .F.
		ENDIF
	CASE LEN(m.tcINN)=12
	OTHERWISE
		llIsCorrect = .F.
	ENDCASE
ENDIF

*  ,      
LOCAL lnI
IF m.llIsCorrect = .T.
	FOR lnI=1 TO LEN(m.tcINN)
		IF IsDigit(SubStr(m.tcINN,m.lnI,1))=.F.
			llIsCorrect = .F.
		ENDIF
	ENDFOR
ENDIF

*       
LOCAL la10(12), la11(12), la12(12)

STORE 0 TO m.la10, m.la11, m.la12

la10[1]=2
la10[2]=4
la10[3]=10
la10[4]=3
la10[5]=5
la10[6]=9
la10[7]=4
la10[8]=6
la10[9]=8

la11[1]=7
la11[2]=2
la11[3]=4
la11[4]=10
la11[5]=3
la11[6]=5
la11[7]=9
la11[8]=4
la11[9]=6
la11[10]=8

la12[1]=3
la12[2]=7
la12[3]=2
la12[4]=4
la12[5]=10
la12[6]=3
la12[7]=5
la12[8]=9
la12[9]=4
la12[10]=6
la12[11]=8

*    
IF m.llIsCorrect = .T. 
	LOCAL lnCheckSum10,lnCheckSum11,lnCheckSum12
	STORE 0 TO m.lnCheckSum10,m.lnCheckSum11,m.lnCheckSum12
	FOR lnI=1 TO 12
		lnCheckSum10 = m.lnCheckSum10+la10[m.lnI]*VAL(SubStr(m.tcINN,m.lnI,1))
		lnCheckSum11 = m.lnCheckSum11+la11[m.lnI]*VAL(SubStr(m.tcINN,m.lnI,1))
		lnCheckSum12 = m.lnCheckSum12+la12[m.lnI]*VAL(SubStr(m.tcINN,m.lnI,1))
	ENDFOR

	lnCheckSum10 = MOD(MOD(m.lnCheckSum10,11),10)
	lnCheckSum11 = MOD(MOD(m.lnCheckSum11,11),10)
	lnCheckSum12 = MOD(MOD(m.lnCheckSum12,11),10)
	
	IF LEN(m.tcINN)=10 AND m.lnCheckSum10<>VAL(RIGHT(m.tcINN,1)) OR ;
		LEN(m.tcINN)=12 AND (m.lnCheckSum11<>VAL(SubStr(m.tcINN,11,1)) OR m.lnCheckSum12<>VAL(RIGHT(m.tcINN,1)))
		
		llIsCorrect = .F.
	ENDIF
ENDIF

RETURN (m.llIsCorrect)